#include "3d.h"
#include <math.h>

float sinTable[256];
float cosTable[256];
char acosTable[256];


void precalcSinCos()
{
	for (int i=0; i<256; ++i)
	{
		sinTable[i]=sin(i*PI/128);
		cosTable[i]=cos(i*PI/128);
	}

}


void rotateVectors(TVector* v, TQuat* q, int count)
{
	//First, calculate a 3*3 rotation matrix
	float mat[9];

	//precalculate some multiples
	float xx= q->x * q->x;
	float xy= q->x * q->y;
	float xz= q->x * q->z;
	float xw= q->x * q->w;
	float yy= q->y * q->y;
	float yz= q->y * q->z;
	float yw= q->y * q->w;
	float zz= q->z * q->z;
	float zw= q->z * q->w;

	//calculate the matrix
	mat[0]= 1 - 2 * ( yy + zz );
	mat[1]=     2 * ( xy - zw );
	mat[2]=     2 * ( xz + yw );

	mat[3]=     2 * ( xy + zw );
	mat[4]= 1 - 2 * ( xx + zz );
	mat[5]=     2 * ( yz - xw );

	mat[6]=     2 * ( xz - yw );
	mat[7]=     2 * ( yz + xw );
	mat[8]= 1 - 2 * ( xx + yy );


	//now, for each vector, multiply by the matrix
	for (int i=0; i<count; ++i, ++v)
	{
		float tx,ty,tz;
		tx=mat[0]*v->x+mat[1]*v->y+mat[2]*v->z;
		ty=mat[3]*v->x+mat[4]*v->y+mat[5]*v->z;
		tz=mat[6]*v->x+mat[7]*v->y+mat[8]*v->z;

		v->x=tx; v->y=ty; v->z=tz;
	}
}

void quatMult(TQuat* dest, TQuat* p, TQuat* q)
{

	dest->w = p->w*q->w - p->x*q->x - p->y*q->y - p->z*q->z;
	dest->x = p->w*q->x + p->x*q->w + p->y*q->z - p->z*q->y;
	dest->y = p->w*q->y + p->y*q->w - p->x*q->z + p->z*q->x;
	dest->z = p->w*q->z + p->z*q->w + p->x*q->y - p->y*q->x;
}

