#include "sw.h"
#include "sw_c.h"
#include "object.h"
#include "ship.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
TObject *SHIP, *MISSILE, *SHELL, *SHELLS, *MISSILES, *SHIELDS, *EXPLOSIONS[10];
int EXPLOSIONSCNT;

TSpace *space;
score_table _scores[MAX_SHIPS];

extern "C" int sw_init()
{
	space=new TSpace(MAX_OBJECTS, _scores);	//the game's space with

	precalcSinCos();	//precalculate sin and cos tables

	//create object templates from separate files
	SHIP = new TObject("ship",20);
	MISSILE = new TObject("missile",5);
	SHELL = new TObject("shell",15);
	SHELLS = new TObject("shells",30);
	MISSILES = new TObject("missiles",10);
	SHIELDS = new TObject("shields",10);

	EXPLOSIONS[0] = new TObject ("expl1",8);
	EXPLOSIONS[1] = new TObject ("expl2",8);
	EXPLOSIONS[2] = new TObject ("expl3",8);
	EXPLOSIONS[3] = new TObject ("expl4",8);
	EXPLOSIONS[4] = new TObject ("expl5",8);
	EXPLOSIONS[5] = new TObject ("expl6",8);
	EXPLOSIONSCNT=6;

	int i;
	for (i=0; i<EXPLOSIONSCNT; ++i) //check for errors in expl[...]
		if (!EXPLOSIONS[i]->isOK()) break;

	//check for object template creation errors
	if (i != EXPLOSIONSCNT || !SHIP->isOK() || !SHELL->isOK() || !MISSILE->isOK() || !SHELLS->isOK() || !MISSILES->isOK() || !SHIELDS->isOK())
	{
		fprintf(stderr,"\nError: could not open source files or allocate template objects\n");
		return(1);
	}
	return 0;
}



char* dump_score_table(char* b) 
{
	int i;
	for (i=0; i<MAX_SHIPS; ++i)
		if (*_scores[i].name) {
			int *bi;
			
			*b++ = i+1;
			bi  = (int*)b;
			*bi++ = htons(_scores[i].deaths);
			*bi++ = htons(_scores[i].kills);
			*bi++ = htons(_scores[i].score);
			b = (char*)bi;
			strcpy(b, _scores[i].name);
			b+=strlen(b)+1;
		}
	*b++=0;
	return b;
	
}
char* read_score_table(char* b)
{
	while (*b) {
		int i;
		int *bi;

		i = *b++ -1;
		bi = (int*)b;
		
		_scores[i].deaths = ntohs(*bi++);
		_scores[i].kills = ntohs(*bi++);
		_scores[i].score = ntohs(*bi++);
		b = (char*)bi;
		strcpy(_scores[i].name, b);
		b+=strlen(b) + 1;
	}

	return b+1;
}

long swrandom(long n)
{
	return rand() % n;
}
