#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <time.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <pwd.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <netdb.h>

#include "sw_c.h"

#include "const.h"

#define FPS 8

GdkGC *gc;
gint32 buff[1000][1000];

struct score_table _scores[MAX_SHIPS];
long cntr=0, rtime=0;
int sock1;
char _keys;

GtkWidget *win_main, *area_game, *vbox_main, *hbox_main, *menu, *vbox_status, *list_score, *list_stats,
		*vbox_game, *progress_speed, *label_locked, *label_messages;

void update_stats()
{
	static int sum;
	char buff[20];
	
	/* has anything changed? */
	if (_speed + _shields + _missiles + _shells == sum) return;
	
	sum=_speed + _shields + _missiles + _shells;
	
	gtk_progress_set_percentage(GTK_PROGRESS(progress_speed), (float)_speed/MAX_SPEED);	
	
	gtk_clist_freeze(GTK_CLIST(list_stats));
	sprintf(buff,"%d", _shields);
	gtk_clist_set_text(GTK_CLIST(list_stats), 0, 1, buff);
	sprintf(buff,"%d", _missiles);
	gtk_clist_set_text(GTK_CLIST(list_stats), 1, 1, buff);
	sprintf(buff,"%d", _shells);
	gtk_clist_set_text(GTK_CLIST(list_stats), 2, 1, buff);
	gtk_clist_thaw(GTK_CLIST(list_stats));

	
	gtk_clist_thaw(GTK_CLIST(list_stats));
}

void update_scores()
{
	int i;

	gtk_clist_freeze(GTK_CLIST(list_score));
	gtk_clist_clear(GTK_CLIST(list_score));
	
	for (i=0; i< MAX_SHIPS; ++i) {
		char score[16], name[16];
		char *content[2]={name, score};
		if (*_scores[i].name) {		
			strncpy(name, _scores[i].name, 15); name[15]=0;
			sprintf(score, "%d", _scores[i].kills - _scores[i].deaths);	
			gtk_clist_append(GTK_CLIST(list_score), content);
		}
	}
	gtk_clist_thaw(GTK_CLIST(list_score));



	
}

gint main_expose(GtkWidget *widget, GdkEvent *event, gpointer data)
{
	return 0;
}

gboolean keyevent(GtkWidget *widget, GdkEventKey *e, gpointer d)
{
	int key=0;	
	
	/* ignore KEY_RELEASE events, that are immediately followed by
	 * an KEY_PRESS event of the same key (these are generated
	 * because of the keyboard's auto-repeat... */
	GdkEvent *nexte;	
	if (gdk_events_pending()) {			/* an event in the queue? */
		nexte = gdk_event_get();		
		if (e->type==GDK_KEY_RELEASE && nexte->type==GDK_KEY_PRESS 
			&& e->keyval==((GdkEventKey*)nexte)->keyval)	
		{
			gdk_event_free(nexte);
			return TRUE;
		}
		else {					/* we retrieved an event that should have stayed in the queue */
			gdk_event_put(nexte);
			gdk_event_free(nexte);
		}
	}	
	
	switch (e->keyval) {
		case GDK_Left: 	key=KEY_LEFT; break;
		case GDK_Right: key=KEY_RIGHT; break;
		case GDK_Up: 	key=KEY_UP; break;
		case GDK_Down: 	key=KEY_DOWN; break;
		case GDK_a: 	key=KEY_FW; break;
		case GDK_z:	key=KEY_BACK; break;
		case GDK_m:	key=KEY_MISSILE; break;
		case GDK_space:	key=KEY_CANNON; break;
			
	}
	if (key) {
		if (e->type==GDK_KEY_PRESS)
			_keys |= key;
		else
		  	_keys &= (255-key);
	}
	return TRUE;
}

static void paint(GdkWindow* win)
{
	sw_draw();	

}

static gint read_data(gpointer window)
{
	char buff[NET_BUFF_SIZE];
	char* b=buff;
	static int last_locked = -2, last_locked_lives=0;
	int len, read_len;
	if (read(sock1, buff, 5)==-1) {
		perror("critical error, read");
		exit(1);
	}
	
	_my_number=*buff;	
	len=ntohs(*((int*)(buff+1)));
	
	read_len=5;
	while (read_len<len) {
		read_len += read(sock1, buff+read_len, len-read_len);
	}
	b=buff+5;
	b=sw_read(b);
	/* new score table? */
	if (*b++) {
		memset(_scores, 0, sizeof(*_scores)*MAX_SHIPS);
		b=read_score_table(b);
		update_scores();
	}
	/* new message? */
	if (*b) {
		puts(b);
		gtk_label_set_text(GTK_LABEL(label_messages), b);
		b += strlen(b);
	} 
	b++;

	if (last_locked != _locked || last_locked_lives != _locked_lives) {
		char buff[32];
		if (_locked >=0) {
			sprintf(buff, "%s : %d", _scores[_locked].name, _locked_lives);
		}
		else
			*buff=0;

		gtk_label_set_text(GTK_LABEL(label_locked), buff);
	}
	
	update_stats();
	paint(window);	
	++cntr;
	gtk_main_iteration_do(FALSE);
	
	write(sock1, &_keys, 1);
	return 1;
}

static void menu_map( GtkWidget * w, gpointer  x )
{
	_map_local = (guint)x?0:1;
}

static void menu_eye_dist( GtkWidget * w, gpointer  x )
{
	_eye_dist += (guint)x?-1:1;
	if (_eye_dist<0) _eye_dist=0;
	if (_eye_dist>16) _eye_dist=16;
}	


int main(int argc, char **argv)
{
	struct passwd* pw;
	struct sockaddr_in addr;
	char buff[30];
	
	gtk_init(&argc, &argv);
	
	sock1 = socket(AF_INET, SOCK_STREAM, 6);
	if (sock1 == -1) {
		perror("creating socket");
		return 1;
	}

	addr.sin_family = AF_INET;
	
	/* is the server name specified on the command line? */
	if (argc<2) {
		int s;
		struct sockaddr_in my_addr;
		char buff[2];
		socklen_t addrlen;
		
		printf ("Waiting for a datagram from the server. If this doesn't work for you, \nenter the server name on the command line.\n");
		
		s = socket(AF_INET, SOCK_DGRAM, 17);
		if (sock1 == -1) {
			perror("creating UDP socket");
			return 1;
		}
		
		my_addr.sin_family = AF_INET;
		my_addr.sin_port = htons(SERVER_PORT);
		my_addr.sin_addr.s_addr = INADDR_ANY;
		if ( bind(s, (struct sockaddr*)&my_addr, sizeof(my_addr)) == -1) {
			perror("bind");
			return 1;
		}
		
		do 
			if (recvfrom(s, buff, 1, MSG_WAITALL, (struct sockaddr*)&addr, &addrlen)==-1)
				perror("recvfrom");
				
		while (*buff !='X');
		
	} else {
		struct hostent* hostent;	
		hostent = gethostbyname(argv[1]);
		if (!hostent) {
			perror("gethostbyname");
			return 1;
		}
		memcpy(&addr.sin_addr.s_addr, hostent->h_addr_list[0], hostent->h_length);
	}

	
	addr.sin_port = htons(SERVER_PORT);
	
	if (connect(sock1, (struct sockaddr*)&addr, sizeof(addr)) == -1) {
		perror("connect");
		return 1;
	}


	pw=getpwuid(getuid());
	strncpy(buff+1, pw->pw_name,15);
	buff[16]=0;	
	write(sock1, buff, 16);
	
	

	
	win_main = gtk_window_new(GTK_WINDOW_TOPLEVEL);		/* main window */
		vbox_main = gtk_vbox_new(FALSE, 0);			/* non-homogenous, no separators */
			{
				GtkItemFactoryEntry menu_items[] = {
				{ "/_Game",		NULL,		NULL, 		0,	"<Branch>"},
				{ "/Game/E_xit",	"<control>X",	gtk_main_quit,	0,	NULL	  },
				{ "/_Stereo",		NULL,		NULL,		0,	"<Branch>"  },
				{ "/Stereo/Eye Dist +",	"W",		menu_eye_dist, 	0,	NULL	  },
				{ "/Stereo/Eye Dist -",	"Q",		menu_eye_dist,	1,	NULL	  },
				{ "/_Map",		NULL,		NULL,		0,	"<Branch>"  },
				{ "/Map/_Local",	"E",		menu_map,	0,	NULL	  },
				{ "/Map/_Auto-scale",	"R",		menu_map,	1,	NULL	  }
				};

				GtkItemFactory *factory;
				GtkAccelGroup *accel;
				int menu_count = sizeof(menu_items) / sizeof (GtkItemFactoryEntry);

				accel = gtk_accel_group_new();
				factory = gtk_item_factory_new(GTK_TYPE_MENU_BAR, "<main>", accel);
				gtk_item_factory_create_items (factory, menu_count, menu_items, NULL);
				gtk_window_add_accel_group(GTK_WINDOW(win_main), accel);
			       	
				menu = gtk_item_factory_get_widget(factory, "<main>");
							
			}
			gtk_box_pack_start(GTK_BOX(vbox_main), menu, FALSE, FALSE, 0);
	
			label_messages = gtk_label_new("Welcome to StereoWars!");
			gtk_box_pack_end(GTK_BOX(vbox_main), label_messages, FALSE, FALSE, 0);	
			
			hbox_main = gtk_hbox_new(FALSE, 3);
				vbox_game = gtk_vbox_new(FALSE, 0);
					area_game = gtk_drawing_area_new();
						gtk_drawing_area_size(GTK_DRAWING_AREA(area_game), 200, 200);
					gtk_box_pack_start(GTK_BOX(vbox_game), area_game, TRUE, TRUE, 0);

					progress_speed = gtk_progress_bar_new();
						gtk_progress_bar_set_bar_style(GTK_PROGRESS_BAR(progress_speed), 
							GTK_PROGRESS_CONTINUOUS);
					gtk_box_pack_end(GTK_BOX(vbox_game), progress_speed, FALSE, FALSE, 0);

				gtk_box_pack_start(GTK_BOX(hbox_main), vbox_game, TRUE, TRUE, 0);
				

				vbox_status = gtk_vbox_new(FALSE, 0);

					gtk_box_pack_start(GTK_BOX(vbox_status), gtk_label_new("You:"), FALSE, FALSE, 0);
					{ 
					char* content[]={"Shields", "", "Missilels", "", "Cannon", ""};

					list_stats = gtk_clist_new(2);
						gtk_clist_set_column_auto_resize(GTK_CLIST(list_stats),0, TRUE);
				 		gtk_clist_set_column_auto_resize(GTK_CLIST(list_stats),1, TRUE);
						gtk_clist_append(GTK_CLIST(list_stats), content);
						gtk_clist_append(GTK_CLIST(list_stats), content+2);
						gtk_clist_append(GTK_CLIST(list_stats), content+4);
						GTK_WIDGET_UNSET_FLAGS(list_stats, GTK_CAN_FOCUS);
					gtk_box_pack_start(GTK_BOX(vbox_status), list_stats, FALSE, FALSE, 0);
					
					label_locked = gtk_label_new("   ");
						gtk_label_set_justify(GTK_LABEL(label_locked), GTK_JUSTIFY_CENTER);
					gtk_box_pack_start(GTK_BOX(vbox_status), label_locked, TRUE, FALSE, 0);
					
					list_score = gtk_clist_new(2);
				 		gtk_clist_set_column_auto_resize(GTK_CLIST(list_score),0, TRUE);
				 		gtk_clist_set_column_auto_resize(GTK_CLIST(list_score),1, TRUE);
						GTK_WIDGET_UNSET_FLAGS(list_score, GTK_CAN_FOCUS);
					gtk_box_pack_end(GTK_BOX(vbox_status), list_score, FALSE, FALSE, 0);
					gtk_box_pack_end(GTK_BOX(vbox_status), gtk_label_new("Players & Scores:"), FALSE, FALSE, 0);
					}			

					
				gtk_box_pack_end(GTK_BOX(hbox_main), vbox_status, FALSE, FALSE, 0);
			gtk_box_pack_end(GTK_BOX(vbox_main), hbox_main, TRUE, TRUE, 0);
			

		gtk_container_add(GTK_CONTAINER(win_main), vbox_main);
	
	
	gtk_signal_connect(GTK_OBJECT(win_main), "destroy", GTK_SIGNAL_FUNC(gtk_main_quit), NULL);
	gtk_signal_connect(GTK_OBJECT(win_main), "key-release-event", GTK_SIGNAL_FUNC(keyevent), NULL);
	gtk_signal_connect(GTK_OBJECT(win_main), "key-press-event", GTK_SIGNAL_FUNC(keyevent), NULL);
	gtk_widget_set_events (GTK_WIDGET(win_main), GDK_KEY_PRESS_MASK | GDK_KEY_RELEASE_MASK | GDK_EXPOSURE_MASK);  
		
	
	gtk_widget_show_all(win_main);
	GTK_WIDGET_SET_FLAGS(area_game, GTK_CAN_FOCUS);
	

		
	gdk_rgb_init();
	gc = gdk_gc_new(area_game->window);



	sw_init();		
	sw_client_init(area_game->window);
	
	gdk_input_add(sock1, GDK_INPUT_READ, (GdkInputFunction)read_data, area_game->window);
	
	gtk_main();
	return 1;
}


